This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 459527 - Performance degradation due to excessive spinlocking in the block layer when using logical volume that spans too many physical volumes
Performance degradation due to excessive spinlocking in the block layer when ...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.3
All Linux
medium Severity medium
: rc
: ---
Assigned To: Mikulas Patocka
Martin Jenner
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-08-19 14:21 EDT by Mikulas Patocka
Modified: 2009-01-20 15:17 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:17:19 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
a patch for the problem (1.61 KB, patch)
2008-08-19 17:07 EDT, Mikulas Patocka
no flags Details | Diff

  None (edit)
Description Mikulas Patocka 2008-08-19 14:21:11 EDT
I'm creating this bugzilla to track the integration of the patch into RHEL 5.

Mike Anderson was doing an OLTP benchmark on a computer with 48 physical
disks mapped to one logical device via device mapper.

He found that there was a slowdown on request_queue->lock in function
generic_unplug_device. The slowdown is caused by the fact that when some
code calls unplug on the device mapper, device mapper calls unplug on all
physical disks. These unplug calls take the spinlock, find that the queue is
already unplugged, release the spinlock and exit.

The test for already unplugged queue can be moved out of the spinlock.
When it was done, there was 18% performance improvement on the whole
benchmark.
Comment 1 Mikulas Patocka 2008-08-19 17:07:48 EDT
Created attachment 314574 [details]
a patch for the problem

A patch for the problem. Test for already unplugged queue outside the spinlock.
Comment 3 Don Zickus 2008-09-10 16:14:56 EDT
in kernel-2.6.18-110.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 7 errata-xmlrpc 2009-01-20 15:17:19 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-0225.html

Note You need to log in before you can comment on or make changes to this bug.